package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Statement

public interface Transaction<RUNTIME_KEY : Any> {
	public suspend fun <qUE : Any?> executeQuery_void2void(compiledQuery: _Statement.Void2Void<qUE, RUNTIME_KEY>)

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_void2row(compiledQuery: _Statement.Void2Row<qUE, RUNTIME_KEY>): OutputRow._Scope<qUE, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_void2rowOrNull(compiledQuery: _Statement.Void2RowOrNull<qUE, RUNTIME_KEY>): OutputRow._Scope<qUE, Unit>?

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_void2table(compiledQuery: _Statement.Void2RowOrNull<qUE, RUNTIME_KEY>): OutputRow._Iterator<qUE, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_params2void(compiledQuery: _Statement.Void2Void<qUE, RUNTIME_KEY>): InputRow._Scope<qUE, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_params2row(compiledQuery: _Statement.Void2Row<qUE, RUNTIME_KEY>): InputRow._Scope<qUE, OutputRow._Scope<qUE, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_params2rowOrNull(compiledQuery: _Statement.Void2RowOrNull<qUE, RUNTIME_KEY>):InputRow._Scope<qUE, OutputRow._Scope<qUE, Unit>?>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeQuery_params2table(compiledQuery: _Statement.Void2RowOrNull<qUE, RUNTIME_KEY>): InputRow._Scope<qUE, OutputRow._Iterator<qUE, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <qUE : Any> _executeBatch_params2void(compiledQuery: _Statement.Void2Void<qUE, RUNTIME_KEY>): InputRow._Iterator<qUE, Unit>

	public suspend fun rollback()

	public suspend fun commit()

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _assertTransactionFinishedAndReleaseResources()
}